-- *** Speed Plate 0.1 by 80T *** --


----------- Config Start -----------

local unitsKey = Keys.Oem5				-- Metric / Imperial toggle Key (Default: "Keys.Oem5" ["\" Back-Slash])
local mph = false						-- Change to "true" to always start with Imperial System (Default: "false")
------------ Config End ------------

local RadioStations = {					-- Params: {Station Index, Station Name (max. 8 *char)}
	{0, "LS ROCKR"},					-- Los Santos Rock Radio
	{1, " POP FM "},					-- Non-Stop-Pop FM
	{2, "RADIO LS"},					-- Radio Los Santos
	{3, "CHANNELX"},					-- Channel X
	{4, "REBEL FM"},					-- Rebel Radio
	{5, "SOUL WAX"},					-- Soulwax FM
	{6, "EAST LOS"},					-- East Los FM
	{7, "WESTCOAST"},					-- West Coast Classics
	{8, " BLAINE "},					-- Blaine County Radio
	{9, "BLUE ARK"},					-- Blue Ark
	{10, "WWIDE FM"},					-- Worldwide FM
	{11, "FLYLO FM"},					-- FlyLo FM
	{12, "LOW DOWN"},					-- The Lowdown 91.1
	{13, " THELAB "},					-- The Lab
	{14, " MIRROR "},					-- Radio Mirror Park
	{15, "SPACE FM"},					-- Space 103.2
	{16, "90S ROCK"},					-- Vinewood Boulevard Radio
	{17, " SELFIE "},					-- Self Radio
	{255, "NO RADIO"}					-- Radio Off
}

local index = "80T"
local ratio = 0
local speed = 0
local speed2 = 0
local loopStart = 0
local loopTimer = 3000
local updInfo = false
local switchInfo = true
local updAgain = false
local updSpeed = false
local toggle = false
local getPlate = true
local restorePlate = false
local infoPlayer = true
local isTuning = false
local carPlate = "NOTPLATE"
local platePlayer = "PEDPLATE"
local plateText = "CALL 911"
local plateSpeed = "ABSOLUTE"
local plateStation = "XSTATION"

local PlateInfo = {}

function PlateInfo.unload()
	if restorePlate then
		VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(PLAYER.GET_PLAYERS_LAST_VEHICLE(), "" .. carPlate .. "")
		restorePlate = false
	end
end

function PlateInfo.init()
	print('*** Speed Plate 0.1 by 80T ***')
end

function PlateInfo.tick()
	local playerPed = PLAYER.PLAYER_PED_ID()
	local playerExists = ENTITY.DOES_ENTITY_EXIST(playerPed)
	
	if(playerExists) then
		if(PED.IS_PED_IN_ANY_VEHICLE(playerPed, false)) then
			local stationIndex = AUDIO.GET_PLAYER_RADIO_STATION_INDEX()
			local currVeh = PED.GET_VEHICLE_PED_IS_IN(playerPed, true)
			local vehSpeed = ENTITY.GET_ENTITY_SPEED(currVeh)
			local kmhSpeed = math.floor(vehSpeed * 3.6)
			local mphSpeed = math.floor(vehSpeed * 2.236936292054)
			
			if getPlate then
				carPlate = VEHICLE.GET_VEHICLE_NUMBER_PLATE_TEXT(currVeh)
				restorePlate = true
				getPlate = false
			end
			
			for i, station in pairs(RadioStations) do
				if stationIndex == station[1] then
					plateStation = station[2]
					break
				end
			end
			
			if(PED.IS_PED_MODEL(playerPed, GAMEPLAY.GET_HASH_KEY("player_zero"))) then
				platePlayer = " MICHAEL"
			elseif(PED.IS_PED_MODEL(playerPed, GAMEPLAY.GET_HASH_KEY("player_one"))) then
				platePlayer = "FRANKLIN"
			elseif(PED.IS_PED_MODEL (playerPed, GAMEPLAY.GET_HASH_KEY ("player_two"))) then
				platePlayer = "TREVOR P"
			end
			
			if get_key_pressed(unitsKey) then
				toggle = true
			elseif toggle then
				if mph then
					mph = false
				else
					mph = true
				end
				toggle = false
			end
			
			if mph then
				speed = mphSpeed
				index = "MPH"
				ratio = 2.236936292054
			else
				speed = kmhSpeed
				index = "KPH"
				ratio = 3.6
			end
			
			if vehSpeed < 10 / ratio then
				plateSpeed = "000" .. speed .. " " .. index .. ""
			elseif vehSpeed < 100 / ratio then
				plateSpeed = "00" .. speed .. " " .. index .. ""
			elseif vehSpeed < 1000 / ratio then
				plateSpeed = "0" .. speed .. " " .. index .. ""
			elseif vehSpeed > 9999 / ratio then
				plateSpeed =  " INSANE "
			end
			
			if speed ~= speed2 then
				updSpeed = true
			else
				updSpeed = false
			end
			
			if AUDIO.IS_RADIO_RETUNING() then
				isTuning = true
			elseif isTuning then
				for i, station in pairs(RadioStations) do
					if stationIndex == station[1] then
						plateText = station[2]
						loopStart = GAMEPLAY.GET_GAME_TIMER()
						switchInfo = true
						infoPlayer = false
						isTuning = false
						updInfo = true
						break
					end
				end
			end
			
			if GAMEPLAY.GET_GAME_TIMER() - loopStart < loopTimer then
				if switchInfo then
					if infoPlayer then
						infoPlayer = false
					else
						infoPlayer = true
					end
					switchInfo = false
				end
			else
				loopStart = GAMEPLAY.GET_GAME_TIMER()
				switchInfo = true
				updInfo = true
				if infoPlayer then
					plateText = platePlayer
				else
					plateText = plateStation
				end
			end
			
			if VEHICLE.IS_VEHICLE_STOPPED(currVeh) then
				if updInfo then
					VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(currVeh, "" .. plateText .. "")
					updInfo = false
				end
			else
				if updSpeed then
					VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(currVeh, "" .. plateSpeed .. "")
					speed2 = speed
				end
			end
		else
			getPlate = true
			if restorePlate then
				VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(PLAYER.GET_PLAYERS_LAST_VEHICLE(), "" .. carPlate .. "")
				restorePlate = false
			end
		end
	end
end

return PlateInfo